# kpatch-build

#### 介绍
kpatch-build 是一款热补丁制作工具，可在不重启系统和中断业务的情况下对操作系统内核进行CVE和Bug修复。

支持架构：
X86，ARM64

上游社区：https://github.com/dynup/kpatch

#### 软件架构
软件架构说明
![输入图片说明](image.png)

#### 安装教程

教程以龙蜥操作系统Anolis OS 8.6，内核版本4.19.91-26.4.an8.x86_64为例说明热补丁制作全流程。

1.安装软件包

yum install -y make gcc patch bison flex openssl-devel elfutils elfutils-devel dwarves

在制作热补丁过程中出现命令或头文件找不到，可以根据出错提示安装对应软件包即可。


2.下载kernel-debuginfo,kernel-devel,kernel source

源代码下载地址： https://anas.openanolis.cn/errata/detail/ANSA-2022:0692

debuginfo地址：https://mirrors.aliyun.com/anolis/8.6/Plus/x86_64/debug/Packages/?spm=a2c6h.25603864.0.0.3b5a47ca8f4z6h

kernel-devel: https://anas.openanolis.cn/errata/detail/ANSA-2022:0692

分别解压三个软件包(rpm2cpio xxx.rpm | cpio -div)，依次提取出vmlinux, .config和kernel source，并放置在同一个目录。


3.下载kpatch-build

wget https://gitee.com/anolis/kpatch-build/repository/archive/master.zip


4.编译kpatch-build

解压master.zip,并编译安装kpatch-build

make BUILDMOD=no

make install


5.制作热补丁


kpatch-build -n kpatch-test  -s /root/hotfix/linux-4.19.91-26.4.an7 -c /root/hotfix/.config -v /root/hotfix/vmlinux -o /root/hotfix/output/ -dddddd -R  /root/hotfix/test-livepatch.patch 

其中：

-s：指向源代码目录

-c: config文件

-v: vmlinux文件

-o: 产物输出目录

test-livepatch.patch：补丁文件

#### 使用说明

加载热补丁：

kpatch load kpatch-test.ko

卸载热补丁：

kpatch unload kpatch-test.ko

热补丁列表：

kpatch list 

#### 参与贡献

1.  Fork 本仓库
2.  新建 Feat_xxx 分支
3.  提交代码
4.  新建 Pull Request